﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO; //以下追加
using QTOLibrary;
using GetTag;

namespace FileToXML
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            string myDoc = System.Environment.GetFolderPath(Environment.SpecialFolder.Personal);
            txtXMLdir.Text = myDoc;
            txtXMLname.Text = "test.xml";
        }

        private void btnM4a_Click(object sender, EventArgs e)
        {
            //M4Aのテスト用
            string m4aPath = @"F:\Test\smplM4A.m4a";
            Dictionary<TagName, string> tagDic;

            GetTagM4a m4a = new GetTagM4a(axQTControl1);
            tagDic = m4a.GetTag(m4aPath);
        }

        private void btnXMLwrite_Click(object sender, EventArgs e)
        {
            Dictionary<string, bool> tagetFiles = new Dictionary<string, bool>();
            for (int i = 0; i < clbxFolders.Items.Count; i++)
            {
                string nam = clbxFolders.Items[i].ToString();
                bool yn = clbxFolders.GetItemChecked(i);
                tagetFiles.Add(nam, yn);
            }
            if (chkItun.Checked)
                tagetFiles.Add(txtITunesDir.Text, true);
            //
            string xmlPath = txtXMLdir.Text + "\\" + txtXMLname.Text;
            MakeTagToXML makeXML = new MakeTagToXML(xmlPath, tagetFiles, axQTControl1);
            if (tagetFiles.Count == 0)
            {
                MessageBox.Show("フォルダが選択されていません");
            }
            else
            {
                int count = 0;
                count = makeXML.GetTagToXML();
                MessageBox.Show("正常終了(" + count.ToString() + "件取得)");
            }

        }

        private void clbxFolders_DragDrop(object sender, DragEventArgs e)
        {
            //ドロップ・フォルダ名を取得する
            string[] item =
                (string[])e.Data.GetData(DataFormats.FileDrop, false);
            for (int i = 0; i < item.Length; i++)
            {
                FileAttributes fas = File.GetAttributes(item[i]);
                if (fas == FileAttributes.Directory)
                {
                    //フォルダ名を追加
                    clbxFolders.Items.Add(item[i]);
                }

            }
        }

        private void clbxFolders_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
                //ドラッグされたデータ形式を調べ、フォルダのときはコピーとする
                e.Effect = DragDropEffects.Copy;
            else
                //フォルダ以外は受け付けない
                e.Effect = DragDropEffects.None;

        }

        private void chkItun_CheckStateChanged(object sender, EventArgs e)
        {
            //bool chkd = chkItun.Checked;
            if (chkItun.Checked)
            {
                txtITunesDir.Text = Environment.GetFolderPath
                    (Environment.SpecialFolder.MyMusic) + @"\iTunes\iTunes Music";
            }
            else
                txtITunesDir.Text = "";
        }

        private void btnSelFord_Click(object sender, EventArgs e)
        {
            //FolderBrowserDialogクラスのインスタンスを作成
            FolderBrowserDialog fbd = new FolderBrowserDialog();

            //上部に表示する説明テキストを指定する
            fbd.Description = "フォルダを指定してください。";
            //ルートフォルダを指定する
            //デフォルトでDesktop
            //fbd.RootFolder = Environment.SpecialFolder.Desktop;
            //最初に選択するフォルダを指定する
            string myDoc= System.Environment.GetFolderPath(Environment.SpecialFolder.Personal);
            //RootFolder以下にあるフォルダである必要がある
            fbd.SelectedPath = myDoc;
            //ユーザーが新しいフォルダを作成できるようにする
            //デフォルトでTrue
            fbd.ShowNewFolderButton = false;

            //ダイアログを表示する
            if (fbd.ShowDialog(this) == DialogResult.OK)
            {
                //選択されたフォルダを表示する
                txtXMLdir.Text = fbd.SelectedPath;
            }

        }

    }
}
