﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms; //以下追加
using System.IO;
using QTOLibrary;
using GetTag;

namespace FileToXML
{
    public class GetTagM4a
    {
        private AxQTOControlLib.AxQTControl QTControl;

        public GetTagM4a(AxQTOControlLib.AxQTControl axQTControl)
        {
            QTControl = axQTControl;
        }


        internal Dictionary<TagName, string> GetTag(string m4aPath)
        {
            SortedDictionary<TagName, string> sortDic
                = new SortedDictionary<TagName, string>();
            QTControl.URL = m4aPath;
            QTOLibrary.QTMovie mov = new QTOLibrary.QTMovie();
            mov = QTControl.Movie;
            Dictionary<TagName, string> retDic = new Dictionary<TagName, string>();
            retDic.Add(TagName.path, m4aPath);
            retDic.Add(TagName.fileName, Path.GetFileName(m4aPath));
            DateTime dt = File.GetCreationTime(m4aPath);
            retDic.Add(TagName.createTime, dt.ToString());
            if (mov == null)
                return retDic;

            //タグ取得（ソート済み）
            string fram = "";
            fram = mov.get_Annotation((int)QTAnnotationsEnum.qtAnnotationArtist);
            if (fram != null)
                sortDic.Add(TagName.artist, fram);
            else
                sortDic.Add(TagName.artist, "");
            fram = mov.get_Annotation((int)QTAnnotationsEnum.qtAnnotationAlbum);
            if (fram != null)
                sortDic.Add(TagName.album, fram);
            else
                sortDic.Add(TagName.album, "");
            fram = mov.get_Annotation((int)QTAnnotationsEnum.qtAnnotationFullName);
            if (fram != null)
                sortDic.Add(TagName.title, fram);
            else
                sortDic.Add(TagName.title, "");
            fram = mov.get_Annotation((int)QTAnnotationsEnum.qtAnnotationGenre);
            if (fram != null)
                sortDic.Add(TagName.genre, fram);
            else
                sortDic.Add(TagName.genre, "");
            fram = mov.get_Annotation((int)QTAnnotationsEnum.qtAnnotationComments);
            if (fram != null)
                sortDic.Add(TagName.comment, fram);
            else
                sortDic.Add(TagName.comment, "");
            fram = mov.get_Annotation((int)QTAnnotationsEnum.qtAnnotationComposer);
            if (fram != null)
                sortDic.Add(TagName.composer, fram);
            else
                sortDic.Add(TagName.composer, "");
            //
            sortDic.Add(TagName.pic, "");
            sortDic.Add(TagName.track, "");
            sortDic.Add(TagName.year, "");
            sortDic.Add(TagName.lyric, "");
            //Dictionary<string, string> retDic = new Dictionary<string, string>();
            //retDic.Add("path", m4aPath);
            //retDic.Add("fileName", Path.GetFileName(m4aPath));
            foreach (TagName id in sortDic.Keys)
            {
                retDic.Add(id, sortDic[id]);
            }
            return retDic;
        }
    }
}
