﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using GatherFile; //*
using GetTag;  //*
using AxQTOControlLib;
using System.Xml;

namespace FileToXML
{
    public class MakeTagToXML
    {
        private Dictionary<string, bool> tagetFiles = new Dictionary<string, bool>();
        private string xmlPath;
        private AxQTControl QTcontr = null;

        public MakeTagToXML(string path, Dictionary<string, bool> files,AxQTControl qtCont)
        {
            tagetFiles = files;
            string folder = Path.GetDirectoryName(path);
            if (Directory.Exists(folder) == false)
                Directory.CreateDirectory(folder);

            xmlPath = path;
            QTcontr = qtCont;
        }

        internal int GetTagToXML()
        {
            //ファイルパス収集
            List<string> songFiles;
            GatherSongFile gather = new GatherSongFile();
            songFiles = gather.GatherInFolder(tagetFiles);
            if (songFiles.Count == 0)
                return 0;

            //XML 準備
            XmlWriter writr = WriteHeadder();
            writr.WriteStartElement("tagList");
            DateTime dt = DateTime.Now;
            writr.WriteAttributeString("Date", dt.ToString());

            int retCount = 0;
            Dictionary<TagName, string> tagDic
                = new Dictionary<TagName, string>();
            GetTagMP3 mp3Tag = new GetTagMP3();
            GetTagM4a m4aTag = new GetTagM4a(QTcontr);
            foreach (string f in songFiles)
            {
                if (File.Exists(f) == false)
                    continue;
                tagDic.Clear();
                string ext = Path.GetExtension(f);
                switch (ext.ToLower())
                {
                    case ".mp3":
                        try
                        {
                            tagDic = mp3Tag.GetTag(f);
                        }
                        catch (Exception ex)
                        {
                            string erTxt = ex.Message;
                            continue;
                        }
                        ++retCount;
                        break;
                    case ".m4a":
                        if (QTcontr != null)
                        {
                            tagDic = m4aTag.GetTag(f);
                            ++retCount;
                        }
                        else
                            tagDic.Clear();
                        break;
                    default:
                        break;
                }
                if (tagDic.Count != 0)
                {
                    //XML Write
                    writr.WriteStartElement("tag");
                    string val = "";
                    foreach (TagName frame in tagDic.Keys)
                    {
                        //writr.WriteStartElement(frame);
                        writr.WriteStartElement(Enum.GetName(typeof(TagName), frame));
                        val = (string)tagDic[frame];
                        if (val.EndsWith("\0"))
                            val = val.Substring(0, val.Length - 1);
                        writr.WriteValue(val);
                        writr.WriteEndElement(); // frame
                    }
                    writr.WriteEndElement(); //tag
                }
            }
            //XML Close
            writr.WriteEndElement(); //tagList
            writr.Close();
            return retCount;
        }
        private XmlWriter WriteHeadder()
        {
            XmlWriterSettings wst = new XmlWriterSettings();
            wst.Encoding = Encoding.UTF8;
            wst.Indent = true;
            wst.IndentChars = "    ";
            XmlWriter retWrtr = XmlWriter.Create(xmlPath, wst);

            return retWrtr;
        }

    }
}
