﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NUnit.Framework;

namespace GatherFile.Test
{
    [TestFixture]
    public class Test_GatherFile
    {
        private Dictionary<string, bool> inpTestData = new Dictionary<string, bool>();

        [Test]
        public void Testフォルダなし()
        {
            List<string> resList = new List<string>();
            inpTestData.Add(@"F:\Test\XYZ", true);

            GatherSongFile gather = new GatherSongFile();
            resList = gather.GatherInFolder(inpTestData);

            Assert.AreEqual(0, resList.Count);
        }

        [Test]
        public void Testフォルダ空()
        {
            List<string> resList = new List<string>();
            inpTestData.Add(@"F:\Test\Non", true);

            GatherSongFile gather = new GatherSongFile();
            resList = gather.GatherInFolder(inpTestData);

            Assert.AreEqual(0, resList.Count);
        }

        [Test]
        public void Testルート()
        {
            List<string> resList = new List<string>();
            inpTestData.Add(@"F:\Test", false);

            GatherSongFile gather = new GatherSongFile();
            resList = gather.GatherInFolder(inpTestData);

            Assert.AreEqual(3, resList.Count);
        }

        [Test]
        public void Testルート再帰()
        {
            List<string> resList = new List<string>();
            inpTestData.Add(@"F:\Test", true);

            GatherSongFile gather = new GatherSongFile();
            resList = gather.GatherInFolder(inpTestData);

            Assert.AreEqual(6, resList.Count);
        }

        [Test]
        public void TestITunes()
        {
            List<string> resList = new List<string>();
            string iTunDir = Environment.GetFolderPath(Environment.SpecialFolder.MyMusic)
                + @"\iTunes\iTunes Music";
            inpTestData.Add(iTunDir, false);

            GatherSongFile gather = new GatherSongFile();
            resList = gather.GatherInFolder(inpTestData);

            Assert.AreEqual(43, resList.Count);
        }
    }
}
